import texttable


def print_xml_record_set(records, fields, labels=None):
    _table = []
    for record in records:
        row = []
        for field in fields:
            if field.startswith('@'):
                row.append(str(record.get(field[1:])))
            else:
                try:
                    row.append(str(record.find(field).text))
                except AttributeError:
                    row.append('')
        _table.append(row)
    print_table(_table, labels=labels)


def print_dict_record_set(records, fields, labels=None):
    _table = []
    for record in records:
        row = []
        for field in fields:
            row.append(str(record[field]))
        _table.append(row)
    print_table(_table, labels=labels)


def print_table(entries, labels=None):
    if labels:
        has_header = True
        rows = [labels] + entries
    else:
        has_header = False
        rows = entries
    _table = texttable.Texttable()
    _table.add_rows(rows, has_header)
    print(_table.draw())
